<!DOCTYPE html>
<html lang="en">
<head>
     <meta charset="UTF-8">
     <meta http-equiv="X-UA-Compatible" content="IE=edge">
     <meta name="viewport" content="width=device-width, initial-scale=1.0">
     <title>Danh sách đăng ký</title> 

     <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
     <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
     <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

     <!-- Import Datatable sau jquery -->
     <!-- Import them style bootstrap cho datatable -->
     <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
     <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
     <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>


</head>
<body>
     <div class="container">
          <h2 style="text-align: center;">Danh sách người dùng</h2>
          <table id="user-table" class="table table-bordered table-striped table-hover"> 
               <thead>
                    <tr>
                         <th>Mã người dùng</th>
                         <th>Firstname</th>
                         <th>Lastname</th>
                         <th>Country</th>
                         <th>Subject</th>
                         <th>Customer Type</th>
                         <th>Register Status</th>
                         <th>Action</th>
                    </tr>
               </thead>
               <tbody>

               </tbody>
          </table>
     </div>
</body>
<script>
     "use strict"
     $(document).ready(function(){
          /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
          const gDATA_COLUMN = [ //gán với tên các côt của array
               "id", 
               "firstname", 
               "lastname", 
               "country",
               "subject", 
               "customerType", 
               "registerStatus", 
               "action"
          ];
          
          const gUSER_ID = 0;
          const gFIRST_NAME = 1;
          const gLAST_NAME = 2;
          const gCOUNTRY = 3;
          const gSUBJECT = 4;
          const gCUSTOMER_TYPE = 5;
          const gREGISTER_STATUS = 6;
          const gACTION = 7;
          $("#user-table").DataTable({
                    "columns": [
                         {"data": gDATA_COLUMN[gUSER_ID]},
                         {"data": gDATA_COLUMN[gFIRST_NAME]},
                         {"data": gDATA_COLUMN[gLAST_NAME]},
                         {"data": gDATA_COLUMN[gCOUNTRY]},
                         {"data": gDATA_COLUMN[gSUBJECT]},
                         {"data": gDATA_COLUMN[gCUSTOMER_TYPE]},
                         {"data": gDATA_COLUMN[gREGISTER_STATUS]},
                         {"data": gDATA_COLUMN[gACTION]},
                    ], 
                    columnDefs: [ //định nghĩa các cột cần hiện ra 
                         {
                           targets: gACTION, //côt action
                           defaultContent: "<button class = 'btn btn-success btn-detail'>Chi tiết</button>"   
                         }

                    ]
               });

          /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
          onPageLoading();

          $(document).on("click", "#user-table .btn-detail", function(){ //gán sue kiên cho nút click
               onBtnDetailClick(this);
          });
          /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
          //hàm xử lý viêc tải trang 
          function onPageLoading(){
               "use strict"
               $.ajax({
                    url: "http://203.171.20.210:8080/devcamp-register-java-api/users", 
                    type: "GET", 
                    dataType: "json", 
                    success: function(res){
                         loadDataToTable(res);
                    },
                    error: function(ajaxConText){
                         alert(ajaxConText.responseText);
                    }
               });

          }
          /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

          //hamf load dữ liêu vào bảng
          function loadDataToTable(paramUserObj){
               "use strict"
               var vTable = $("#user-table").DataTable(); //tao biến truy xuất đến datatable
               vTable.clear();
               vTable.rows.add(paramUserObj);
               vTable.draw();
          }


          //hàm xử lý khi nút chi tiết được click
          function onBtnDetailClick(paramEle){
               "use strict"
               var vRowClick = $(paramEle).parents("tr"); //xác định cha tr chứa nút click
               var vTable = $("#user-table").DataTable(); //taoj biến truy xuất đén datatable
               var vDataRow = vTable.row(vRowClick).data(); //lấy dữ liệu của hàng dữ liêu chứa nút click 
               
               console.log("User Id: " + vDataRow.id);
               console.log("First Name: " + vDataRow.firstname);
               console.log("Last Name: " + vDataRow.lastname);
               console.log("Country: " + vDataRow.country);
               console.log("Subject: " + vDataRow.subject);
               console.log("Customer Type: " + vDataRow.customerType);
               console.log("Register Status: " + vDataRow.registerStatus);
          }

     });
</script>
</html>